Index: trunk/hardware/ps_trunk.b#1
===================================================================
--- trunk/hardware/ps_trunk.b#1	(revision 7)
+++ trunk/hardware/ps_trunk.b#1	(revision 8)
@@ -4,10 +4,10 @@
 <drawing>
 <settings>
-<setting alwaysvectorfont="yes"/>
+<setting alwaysvectorfont="no"/>
 <setting verticaltext="up"/>
 </settings>
 <grid distance="0.5" unitdist="mm" unit="mm" style="lines" multiple="2" display="yes" altdistance="5" altunitdist="mil" altunit="mil"/>
 <layers>
-<layer number="1" name="Top" color="4" fill="1" visible="no" active="yes"/>
+<layer number="1" name="Top" color="4" fill="1" visible="yes" active="yes"/>
 <layer number="2" name="Route2" color="16" fill="1" visible="no" active="no"/>
 <layer number="3" name="Route3" color="17" fill="1" visible="no" active="no"/>
@@ -25,5 +25,5 @@
 <layer number="15" name="Route15" color="23" fill="1" visible="no" active="no"/>
 <layer number="16" name="Bottom" color="1" fill="1" visible="no" active="yes"/>
-<layer number="17" name="Pads" color="2" fill="1" visible="no" active="yes"/>
+<layer number="17" name="Pads" color="2" fill="1" visible="yes" active="yes"/>
 <layer number="18" name="Vias" color="2" fill="1" visible="no" active="yes"/>
 <layer number="19" name="Unrouted" color="6" fill="1" visible="no" active="yes"/>
@@ -172,4 +172,14 @@
 <wire x1="40" y1="16" x2="56" y2="24" width="5" layer="103"/>
 <wire x1="56" y1="24" x2="56" y2="57" width="5" layer="103"/>
+<text x="44" y="12" size="3.81" layer="21" font="vector" ratio="15">+</text>
+<text x="53.5" y="12" size="3.81" layer="21" font="vector" ratio="15">+</text>
+<text x="63" y="12" size="3.81" layer="21" font="vector" ratio="15">+</text>
+<text x="68" y="12" size="3.81" layer="21" font="vector" ratio="15">-</text>
+<text x="58.5" y="12" size="3.81" layer="21" font="vector" ratio="15">-</text>
+<text x="49" y="12" size="3.81" layer="21" font="vector" ratio="15">-</text>
+<wire x1="52.5" y1="10" x2="52.5" y2="16" width="0.254" layer="21"/>
+<wire x1="62" y1="10" x2="62" y2="16" width="0.254" layer="21"/>
+<wire x1="71.5" y1="10" x2="71.5" y2="16" width="0.254" layer="21"/>
+<wire x1="43" y1="10" x2="43" y2="16" width="0.254" layer="21"/>
 </plain>
 <libraries>
@@ -2042,6 +2052,7 @@
 </autorouter>
 <elements>
-<element name="C6" library="rcl" library_urn="urn:adsk.eagle:library:334" package="C150-054X183" package3d_urn="urn:adsk.eagle:package:23669/1" override_package3d_urn="urn:adsk.eagle:package:35666444/3" override_package_urn="urn:adsk.eagle:footprint:23162/1" value="1n/275V" x="40" y="27" smashed="yes" rot="R180">
+<element name="C6" library="rcl" library_urn="urn:adsk.eagle:library:334" package="C150-054X183" package3d_urn="urn:adsk.eagle:package:23669/1" override_package3d_urn="urn:adsk.eagle:package:35666444/3" override_package_urn="urn:adsk.eagle:footprint:23162/1" value="10n/275V" x="40" y="27" smashed="yes" rot="R180">
 <attribute name="NAME" x="48.382" y="24.079" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C005" x="40" y="27" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="3" x="-0.64" y="119.71" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="-0.64" y="119.71" size="1.778" layer="27" rot="R180" display="off"/>
@@ -2050,4 +2061,5 @@
 <element name="C4" library="rcl" library_urn="urn:adsk.eagle:library:334" package="C1210" package3d_urn="urn:adsk.eagle:package:23619/2" value="1µ/100V" x="86" y="32" smashed="yes" rot="R180">
 <attribute name="NAME" x="87.905" y="30.095" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C216" x="86" y="32" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="0" x="66.95" y="124.71" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="66.95" y="124.71" size="1.778" layer="27" rot="R180" display="off"/>
@@ -2056,4 +2068,5 @@
 <element name="C3" library="rcl" library_urn="urn:adsk.eagle:library:334" package="C1210" package3d_urn="urn:adsk.eagle:package:23619/2" value="1µ/100V" x="86" y="37" smashed="yes" rot="R180">
 <attribute name="NAME" x="87.905" y="35.095" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C216" x="86" y="37" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="0" x="58.06" y="129.71" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="58.06" y="129.71" size="1.778" layer="27" rot="R180" display="off"/>
@@ -2062,22 +2075,26 @@
 <element name="C7" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="33µ/80V" x="86" y="21" smashed="yes" rot="R270">
 <attribute name="NAME" x="88" y="14" size="1.27" layer="25" font="vector" ratio="12"/>
+<attribute name="PARTNO" value="C224" x="86" y="21" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="POPULARITY" value="2" x="2.18" y="1.95" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="2.18" y="1.95" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="VALUE" x="83.325" y="23.55" size="1.016" layer="27" rot="R270"/>
 </element>
-<element name="C1" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="3,9µF/500V" x="23" y="53" smashed="yes" rot="R180">
+<element name="C1" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="2,2µF/450V" x="23" y="53" smashed="yes" rot="R180">
 <attribute name="NAME" x="18.55" y="58.25" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C449" x="23" y="53" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="2" x="-8.75" y="136.82" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="-8.75" y="136.82" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="VALUE" x="25.55" y="55.675" size="1.016" layer="27" rot="R180"/>
 </element>
-<element name="C2" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="3,9µF/500V" x="23" y="42" smashed="yes" rot="R180">
+<element name="C2" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="2,2µF/450V" x="23" y="42" smashed="yes" rot="R180">
 <attribute name="NAME" x="19.05" y="47.25" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C449" x="23" y="42" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="2" x="-21.45" y="125.82" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="-21.45" y="125.82" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="VALUE" x="25.55" y="44.675" size="1.016" layer="27" rot="R180"/>
 </element>
-<element name="C5" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="3,9µF/500V" x="23" y="31" smashed="yes" rot="R180">
+<element name="C5" library="rcl" library_urn="urn:adsk.eagle:library:334" package="PANASONIC_G" package3d_urn="urn:adsk.eagle:package:23427/2" value="2,2µF/450V" x="23" y="31" smashed="yes" rot="R180">
 <attribute name="NAME" x="19.05" y="36.25" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="C449" x="23" y="31" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="2" x="-34.15" y="114.82" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="C" x="-34.15" y="114.82" size="1.778" layer="27" rot="R180" display="off"/>
@@ -2086,4 +2103,5 @@
 <element name="D5" library="diode" library_urn="urn:adsk.eagle:library:210" package="SMBJ" package3d_urn="urn:adsk.eagle:package:43442/2" value="SMBJ24A" x="78" y="21" smashed="yes" rot="R90">
 <attribute name="NAME" x="75" y="20" size="1.27" layer="25" font="vector" ratio="12" rot="R90"/>
+<attribute name="PARTNO" value="D212" x="78" y="21" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="POPULARITY" value="3" x="160.55" y="92.12" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="VALUE" x="81.81" y="19.095" size="1.27" layer="27" rot="R90"/>
@@ -2091,4 +2109,5 @@
 <element name="D4" library="diode" library_urn="urn:adsk.eagle:library:210" package="SMC" package3d_urn="urn:adsk.eagle:package:43425/2" value="MURS360" x="13" y="31" smashed="yes" rot="R90">
 <attribute name="NAME" x="9.641" y="27.541" size="1.27" layer="25" font="vector" ratio="12" rot="R90"/>
+<attribute name="PARTNO" value="D049" x="13" y="31" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="POPULARITY" value="1" x="84.12" y="72.91" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="VALUE" x="17.629" y="27.541" size="1.27" layer="27" rot="R90"/>
@@ -2096,4 +2115,5 @@
 <element name="D3" library="diode" library_urn="urn:adsk.eagle:library:210" package="SMC" package3d_urn="urn:adsk.eagle:package:43425/2" value="MURS360" x="5" y="31" smashed="yes" rot="R90">
 <attribute name="NAME" x="1.641" y="27.541" size="1.27" layer="25" font="vector" ratio="12" rot="R90"/>
+<attribute name="PARTNO" value="D049" x="5" y="31" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="POPULARITY" value="1" x="76.12" y="84.34" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="VALUE" x="9.629" y="27.541" size="1.27" layer="27" rot="R90"/>
@@ -2101,4 +2121,5 @@
 <element name="D2" library="diode" library_urn="urn:adsk.eagle:library:210" package="SMC" package3d_urn="urn:adsk.eagle:package:43425/2" value="MURS360" x="13" y="44" smashed="yes" rot="R90">
 <attribute name="NAME" x="9.641" y="40.541" size="1.27" layer="25" font="vector" ratio="12" rot="R90"/>
+<attribute name="PARTNO" value="D049" x="13" y="44" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="POPULARITY" value="1" x="84.12" y="108.77" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="VALUE" x="17.629" y="40.541" size="1.27" layer="27" rot="R90"/>
@@ -2106,4 +2127,5 @@
 <element name="D1" library="diode" library_urn="urn:adsk.eagle:library:210" package="SMC" package3d_urn="urn:adsk.eagle:package:43425/2" value="MURS360" x="5" y="44" smashed="yes" rot="R90">
 <attribute name="NAME" x="1.641" y="40.541" size="1.27" layer="25" font="vector" ratio="12" rot="R90"/>
+<attribute name="PARTNO" value="D049" x="5" y="44" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="POPULARITY" value="1" x="76.12" y="120.2" size="1.778" layer="27" rot="R90" display="off"/>
 <attribute name="VALUE" x="9.629" y="40.541" size="1.27" layer="27" rot="R90"/>
@@ -2115,4 +2137,5 @@
 <attribute name="NAME" x="12" y="25.5" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 7448030333 " x="36.13" y="-38.38" size="1.778" layer="27" display="off"/>
+<attribute name="PARTNO" value="L072" x="12" y="17.5" size="1.778" layer="27" display="off"/>
 <attribute name="RDC" value="90mOhm" x="36.13" y="-38.38" size="1.778" layer="27" display="off"/>
 <attribute name="VALUE" x="7.9" y="8.5" size="1.27" layer="27"/>
@@ -2122,4 +2145,5 @@
 <element name="LED1" library="led" library_urn="urn:adsk.eagle:library:259" package="CHIP-LED0603" package3d_urn="urn:adsk.eagle:package:15819/3" value="gn" x="70" y="15" smashed="yes" rot="R270">
 <attribute name="NAME" x="70" y="17" size="1.27" layer="25" font="vector" ratio="12"/>
+<attribute name="PARTNO" value="D078" x="70" y="15" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="POPULARITY" value="26" x="-21.44" y="-38.34" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="VALUE" x="69.365" y="13.095" size="1.27" layer="27"/>
@@ -2127,4 +2151,5 @@
 <element name="R1" library="rcl" library_urn="urn:adsk.eagle:library:334" package="R0603" package3d_urn="urn:adsk.eagle:package:23555/3" value="10k" x="67" y="15" smashed="yes" rot="R180">
 <attribute name="NAME" x="66" y="17" size="1.27" layer="25" font="vector" ratio="12"/>
+<attribute name="PARTNO" value="R221" x="67" y="15" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="POPULARITY" value="70" x="7.31" y="106.44" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="SPICEPREFIX" value="R" x="7.31" y="106.44" size="1.778" layer="27" rot="R180" display="off"/>
@@ -2133,4 +2158,5 @@
 <element name="M1" library="PSK-30D-24" package="IRM-20" override_package3d_urn="urn:adsk.eagle:package:35666486/2" override_package_urn="urn:adsk.eagle:footprint:35666487/1" value="IRM20" x="56" y="44" smashed="yes" rot="R180">
 <attribute name="NAME" x="82.41" y="29.1" size="1.27" layer="25" font="vector" ratio="12" rot="R180"/>
+<attribute name="PARTNO" value="BGEK075" x="56" y="44" size="1.778" layer="27" rot="R180" display="off"/>
 <attribute name="VALUE" x="82.4" y="58.85" size="1.27" layer="27" rot="R180" align="top-left"/>
 </element>
@@ -2142,4 +2168,5 @@
 <attribute name="NAME" x="27" y="23.89" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 820512511 " x="27" y="17" size="1.778" layer="27" rot="R270" display="off"/>
+<attribute name="PARTNO" value="R055" x="27" y="17" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="PDISS" value="0.4W" x="27" y="17" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="VALUE" x="22.1" y="20.65" size="1.27" layer="27" rot="R270"/>
@@ -2155,4 +2182,5 @@
 <attribute name="NAME" x="37.39" y="17" size="1.27" layer="25" font="vector" ratio="12" rot="R270" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 820512511 " x="33.5" y="17" size="1.778" layer="27" rot="R270" display="off"/>
+<attribute name="PARTNO" value="R055" x="33.5" y="17" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="PDISS" value="0.4W" x="33.5" y="17" size="1.778" layer="27" rot="R270" display="off"/>
 <attribute name="VALUE" x="28.6" y="28.65" size="1.27" layer="27" rot="R270"/>
@@ -2168,4 +2196,5 @@
 <attribute name="NAME" x="17.5" y="7.5" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 691322310004 " x="28" y="8" size="1.778" layer="27" display="off"/>
+<attribute name="PARTNO" value="CON354" x="28" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PINS" value=" 4 " x="28" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PITCH" value="3.81mm" x="28" y="8" size="1.778" layer="27" display="off"/>
@@ -2182,4 +2211,5 @@
 <attribute name="NAME" x="67" y="10" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 691322310002 " x="67" y="8" size="1.778" layer="27" display="off"/>
+<attribute name="PARTNO" value="CON353" x="67" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PINS" value=" 2 " x="67" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PITCH" value="3.81mm" x="67" y="8" size="1.778" layer="27" display="off"/>
@@ -2196,4 +2226,5 @@
 <attribute name="NAME" x="48" y="10" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 691322310002 " x="48" y="8" size="1.778" layer="27" display="off"/>
+<attribute name="PARTNO" value="CON353" x="48" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PINS" value=" 2 " x="48" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PITCH" value="3.81mm" x="48" y="8" size="1.778" layer="27" display="off"/>
@@ -2210,4 +2241,5 @@
 <attribute name="NAME" x="57.5" y="10" size="1.27" layer="25" font="vector" ratio="12" align="bottom-center"/>
 <attribute name="PART-NUMBER" value=" 691322310002 " x="57.5" y="8" size="1.778" layer="27" display="off"/>
+<attribute name="PARTNO" value="CON353" x="57.5" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PINS" value=" 2 " x="57.5" y="8" size="1.778" layer="27" display="off"/>
 <attribute name="PITCH" value="3.81mm" x="57.5" y="8" size="1.778" layer="27" display="off"/>