Index: trunk/hardware/heater280_304.brd
===================================================================
--- trunk/hardware/heater280_304.brd	(revision 15)
+++ trunk/hardware/heater280_304.brd	(revision 16)
@@ -2685,20 +2685,4 @@
 <rectangle x1="-0.1999" y1="-0.3" x2="0.1999" y2="0.3" layer="35"/>
 </package>
-<package name="R1206" urn="urn:adsk.eagle:footprint:23047/1" library_version="11">
-<description>&lt;b&gt;RESISTOR&lt;/b&gt;</description>
-<wire x1="0.9525" y1="-0.8128" x2="-0.9652" y2="-0.8128" width="0.1524" layer="51"/>
-<wire x1="0.9525" y1="0.8128" x2="-0.9652" y2="0.8128" width="0.1524" layer="51"/>
-<wire x1="-2.473" y1="0.983" x2="2.473" y2="0.983" width="0.0508" layer="39"/>
-<wire x1="2.473" y1="0.983" x2="2.473" y2="-0.983" width="0.0508" layer="39"/>
-<wire x1="2.473" y1="-0.983" x2="-2.473" y2="-0.983" width="0.0508" layer="39"/>
-<wire x1="-2.473" y1="-0.983" x2="-2.473" y2="0.983" width="0.0508" layer="39"/>
-<smd name="2" x="1.422" y="0" dx="1.6" dy="1.803" layer="1"/>
-<smd name="1" x="-1.422" y="0" dx="1.6" dy="1.803" layer="1"/>
-<text x="-1.27" y="1.27" size="1.27" layer="25">&gt;NAME</text>
-<text x="-1.27" y="-2.54" size="1.27" layer="27">&gt;VALUE</text>
-<rectangle x1="-1.6891" y1="-0.8763" x2="-0.9525" y2="0.8763" layer="51"/>
-<rectangle x1="0.9525" y1="-0.8763" x2="1.6891" y2="0.8763" layer="51"/>
-<rectangle x1="-0.3" y1="-0.7" x2="0.3" y2="0.7" layer="35"/>
-</package>
 </packages>
 <packages3d>
@@ -2707,10 +2691,4 @@
 <packageinstances>
 <packageinstance name="C0603"/>
-</packageinstances>
-</package3d>
-<package3d name="R1206" urn="urn:adsk.eagle:package:23540/2" type="model" library_version="11">
-<description>RESISTOR</description>
-<packageinstances>
-<packageinstance name="R1206"/>
 </packageinstances>
 </package3d>
@@ -2881,9 +2859,9 @@
 </packages3d>
 </library>
-<library name="wirepad" urn="urn:adsk.eagle:library:412">
+<library name="wirepad">
 <description>&lt;b&gt;Single Pads&lt;/b&gt;&lt;p&gt;
 &lt;author&gt;Created by librarian@cadsoft.de&lt;/author&gt;</description>
 <packages>
-<package name="3,81/1,4" urn="urn:adsk.eagle:footprint:30817/1" library_version="2">
+<package name="3,81/1,4" urn="urn:adsk.eagle:footprint:30817/1" locally_modified="yes">
 <description>&lt;b&gt;THROUGH-HOLE PAD&lt;/b&gt;</description>
 <wire x1="1.905" y1="-1.27" x2="1.905" y2="-1.905" width="0.1524" layer="21"/>
@@ -2896,5 +2874,5 @@
 <wire x1="1.905" y1="1.905" x2="1.905" y2="1.27" width="0.1524" layer="21"/>
 <circle x="0" y="0" radius="1.27" width="0.1524" layer="51"/>
-<pad name="1" x="0" y="0" drill="1.397" diameter="3.81" shape="octagon"/>
+<pad name="1" x="0" y="0" drill="1.8" diameter="3.81" shape="octagon"/>
 <text x="-1.905" y="2.286" size="1.27" layer="25" ratio="10">&gt;NAME</text>
 <text x="0" y="1.2" size="0.0254" layer="27">&gt;VALUE</text>
@@ -2902,5 +2880,5 @@
 </packages>
 <packages3d>
-<package3d name="3,81/1,4" urn="urn:adsk.eagle:package:30835/1" type="box" library_version="2">
+<package3d name="3,81/1,4" urn="urn:adsk.eagle:package:30835/1" type="box">
 <description>THROUGH-HOLE PAD</description>
 <packageinstances>
@@ -3229,9 +3207,9 @@
 <attribute name="WORKING-VOLTAGE-VDE" value="300V (AC)" x="90.46" y="202.01" size="1.778" layer="27" rot="R180" display="off"/>
 </element>
-<element name="PAD1" library="wirepad" library_urn="urn:adsk.eagle:library:412" package="3,81/1,4" package3d_urn="urn:adsk.eagle:package:30835/1" value="" x="77.72" y="207.26" smashed="yes">
+<element name="PAD1" library="wirepad" package="3,81/1,4" package3d_urn="urn:adsk.eagle:package:30835/1" value="" x="77.72" y="207.26" smashed="yes">
 <attribute name="POPULARITY" value="14" x="77.72" y="207.26" size="1.778" layer="27" display="off"/>
 <attribute name="VALUE" x="77.72" y="208.46" size="0.0254" layer="27"/>
 </element>
-<element name="PAD2" library="wirepad" library_urn="urn:adsk.eagle:library:412" package="3,81/1,4" package3d_urn="urn:adsk.eagle:package:30835/1" value="" x="83.82" y="207.26" smashed="yes">
+<element name="PAD2" library="wirepad" package="3,81/1,4" package3d_urn="urn:adsk.eagle:package:30835/1" value="" x="83.82" y="207.26" smashed="yes">
 <attribute name="POPULARITY" value="14" x="83.82" y="207.26" size="1.778" layer="27" display="off"/>
 <attribute name="VALUE" x="83.82" y="208.46" size="0.0254" layer="27"/>
@@ -3263,28 +3241,4 @@
 </element>
 <element name="U$1" library="logo" package="CE-4MM" value="" x="27.5" y="202.375" smashed="yes"/>
-<element name="R4" library="rcl" library_urn="urn:adsk.eagle:library:334" package="R1206" package3d_urn="urn:adsk.eagle:package:23540/2" value="" x="16.8" y="201" smashed="yes" rot="R180">
-<attribute name="PARTNO" value="R493" x="16.8" y="201" size="1.778" layer="27" rot="R180" display="off"/>
-<attribute name="POPULARITY" value="41" x="16.8" y="201" size="1.778" layer="27" rot="R180" display="off"/>
-<attribute name="SPICEPREFIX" value="R" x="16.8" y="201" size="1.778" layer="27" rot="R180" display="off"/>
-<attribute name="VALUE" x="18.07" y="203.54" size="1.27" layer="27" rot="R180"/>
-</element>
-<element name="R5" library="rcl" library_urn="urn:adsk.eagle:library:334" package="R1206" package3d_urn="urn:adsk.eagle:package:23540/2" value="" x="16.8" y="201" smashed="yes" rot="MR0">
-<attribute name="PARTNO" value="R493" x="16.8" y="201" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="POPULARITY" value="41" x="16.8" y="201" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="SPICEPREFIX" value="R" x="16.8" y="201" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="VALUE" x="18.07" y="198.46" size="1.27" layer="28" rot="MR0"/>
-</element>
-<element name="R6" library="rcl" library_urn="urn:adsk.eagle:library:334" package="R1206" package3d_urn="urn:adsk.eagle:package:23540/2" value="" x="156.8" y="201.1" smashed="yes">
-<attribute name="PARTNO" value="R493" x="156.8" y="201.1" size="1.778" layer="27" display="off"/>
-<attribute name="POPULARITY" value="41" x="156.8" y="201.1" size="1.778" layer="27" display="off"/>
-<attribute name="SPICEPREFIX" value="R" x="156.8" y="201.1" size="1.778" layer="27" display="off"/>
-<attribute name="VALUE" x="155.53" y="198.56" size="1.27" layer="27"/>
-</element>
-<element name="R7" library="rcl" library_urn="urn:adsk.eagle:library:334" package="R1206" package3d_urn="urn:adsk.eagle:package:23540/2" value="" x="156.8" y="201.1" smashed="yes" rot="MR0">
-<attribute name="PARTNO" value="R493" x="156.8" y="201.1" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="POPULARITY" value="41" x="156.8" y="201.1" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="SPICEPREFIX" value="R" x="156.8" y="201.1" size="1.778" layer="28" rot="MR0" display="off"/>
-<attribute name="VALUE" x="158.07" y="198.56" size="1.27" layer="28" rot="MR0"/>
-</element>
 </elements>
 <signals>